#include "configuration.hpp"
#include <avr/eeprom.h>

using namespace Voltmeter;

static Configuration SavedConfiguration EEMEM;


void Configuration::Read()
{
    Configuration result;

    eeprom_read_block(&result, &SavedConfiguration, sizeof(Configuration));

    if (result.validityBeacon == validityBeacon)
    {
        *this = result;
    }
}


void Configuration::Write()
{
    eeprom_write_block(this, &SavedConfiguration, sizeof(Configuration));
}


uint32_t Configuration::GetCalibration(Range const range)
{
    return calibration[(int) range];
}


void Configuration::SetCalibration(Range const range, uint32_t value)
{
    calibration[(int) range] = value;
}
