#pragma once

#include <stdint.h>
#include <avr/sleep.h>
#include <util/atomic.h>


namespace Devices::Mcu
{
    struct PowerManagement
    {
        static void Sleep(uint8_t mode, bool bodDisable)
        {
            ATOMIC_BLOCK(ATOMIC_RESTORESTATE)
            {
                set_sleep_mode(mode);
                sleep_enable();

                if (bodDisable)
                {
                    sleep_bod_disable();
                }

                sei();
                sleep_cpu();
                sleep_disable();
            }
        }

        static void PowerDown(bool bodDisable)
        {
            Sleep(SLEEP_MODE_PWR_DOWN, bodDisable);
        }

        static void PowerSave(bool bodDisable)
        {
            Sleep(SLEEP_MODE_PWR_SAVE, bodDisable);
        }

        static void AdcNoiseCancellation(bool bodDisable)
        {
            Sleep(SLEEP_MODE_ADC, bodDisable);
        }
    };
}